/***************************************************************************
 *   Copyright (C) 2007 Mikhail Fedotov                                    *
 *   anyremote@mail.ru                                                     *
 *   http://anyremote.sf.net                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* ANYREMOTED PLUGIN FOR THE KOPETE KDE INSTANT MESSANGER
 *
 * base class header
 *
 */

#ifndef KOPETE_ANYREMOTE_PLUGIN_H
#define KOPETE_ANYREMOTE_PLUGIN_H

#include <qdict.h>
#include <qstring.h>

#include <kopeteplugin.h>
#include <kopeteonlinestatus.h>

class KopeteAnyremoteUserPrefs;


class KopeteAnyremotePlugin : public Kopete::Plugin //, public KSpeech_stub
{
	Q_OBJECT

public:
	static KopeteAnyremotePlugin* self();

	KopeteAnyremotePlugin( QObject* parent, const char* name, const QStringList& args );
	~KopeteAnyremotePlugin();
	void dumpMessage(QString id, QString data, int type);
	void dumpAllContactsInfo(QString id);

private:
	static KopeteAnyremotePlugin* pluginStatic_;

	void initialize();
	void readMessage( QString message );
	//void announceStatusChange(void); // KopeteAnyremoteUserPrefs* prefs, QString mcId, QString statusDescription );
	void announceIncomingMessage( KopeteAnyremoteUserPrefs* prefs );
	void delFile(QString file);

	KopeteAnyremoteUserPrefs* getUserPrefs( Kopete::MetaContact* mc );
	QDict<KopeteAnyremoteUserPrefs> userPrefs;
	QPtrList<Kopete::ChatSession> freshSessions;

private slots:
	void slotSessionCreated( Kopete::ChatSession* session );
	void slotIncomingMessage( Kopete::Message& msg );
	void slotOutgoingMessage( Kopete::Message& msg );
	void slotOnlineStatusChanged( Kopete::MetaContact* mc, Kopete::OnlineStatus::StatusType status );
	void slotMetaContactAdded( Kopete::MetaContact* mc );
	void slotSettingsChanged();
	void slotShowUserPrefsDialog();
	void slotAccountOnlineStatusChanged();
	void slotTimerDump();

};

#endif
